/*
  ORDMotors.h - Library for using ORDuino Module
*/
	
/*
 * Written by Konstantin Kostyuk et al., Sep 05, 2010.
 * Copyright (c) 2010 4Robots. For more information, see
 * Ver: 0.1 05.09.2010
 *
 *   http://www.4Robots.ru
 *   http://www.Ardubot.ru
 *   http://roboforum.ru/wiki/Open_Robotics
 *
 * You may freely modify and share this code, as long as you keep this
 * notice intact (including the 3 links above).  Licensed under the
 * Creative Commons BY-SA 3.0 license:
 *
 *   http://creativecommons.org/licenses/by-sa/3.0/
 *
 */

#ifndef ORDMotors_h
#define ORDMotors_h

#define MOTOR_OFF 0
#define MOTOR_MAX 255

#define MOTOR_FORWARD 0
#define MOTOR_REVERSE 1

#define MOTOR_LEFT 0
#define PIN_DIR_1A 8 //motor Left Forward/Reverse PIN
#define PIN_PWM_2A 9 //motor Left PWM PIN

#define MOTOR_RIGHT 1
#define PIN_DIR_1B 7 //motor Right Forward/Reverse PIN
#define PIN_PWM_2B 10 //motor Right PWM PIN

// class Motors
class ORDMotors
{
  private:
  int cSpeedM1; //current speed for motor 1
  int cSpeedM2; //current speed for motor 2
  unsigned char StepPWM; //step into milisec for PWM regulate

	// sets the motor speed.  The sign of 'speed' determines the direction
	// and the magnitude determines the speed.  limits: -255 <= speed < 255
	// |speed| = 255 produces the maximum speed while speed = 0 is full brake.
	void setM1Speed(int speed);
	void setM2Speed(int speed);
  	
  public:

  // constructor (set Pins)
	ORDMotors();
	
  int getM1Speed();
  int getM2Speed();
 	void setSpeeds(int m1Speed, int m2Speed);
  void setM1SpeedPWM(int speed);
	void setM2SpeedPWM(int speed); 	
 	void setSpeedsPWM(int m1Speed, int m2Speed);
	
};

#endif
